$nocompile
Dim Z As Byte
Dim Datalo As Byte
Dim Datahi As Byte
Dim Daten As Word At Datalo Overlay
Dim Regno As Byte
Dim Channello As Byte
Dim Channelhi As Byte
Dim Channel As Word At Channello Overlay
Dim Strg As Byte
Dim I As Byte
'Subroutinen fr das I2C-Radio AR1010
Const Arwr = &H20
Const Arrd = &H21

'-------------------------------------------------------------------------------
Initar1010:
Dim Temp As Byte
Restore Regdefaults

For Temp = 1 To 18
   Regno = Temp
   If Temp = 18 Then Regno = 0
   Daten = 00       ' reset chip
   Gosub Writeword
   Read Daten
   Gosub Writeword
Next Temp

Gosub Set_hmute_bit
Return

'-------------------------------------------------------------------------------
Stc:
Waitms 500
Do
Regno = &H13
Gosub Readword
Waitms 300
Loop Until Datalo.5 = 1       ' wait for STC flag
Return

'-------------------------------------------------------------------------------
Tune:
Gosub Set_hmute_bit
Gosub Clear_tune_bit
Gosub Clear_seek_bit
Gosub Setchannel
Gosub Set_tune_bit
Gosub Stc
Gosub Clear_hmute_bit
Return
'-------------------------------------------------------------------------------
Set_hmute_bit:
Regno = &H01
Gosub Readword
Datalo = Datalo Or &B00000010
Gosub Writeword
Return

'-------------------------------------------------------------------------------
Clear_hmute_bit:
Regno = &H01
Gosub Readword
Datalo = Datalo And &B11111101
Gosub Writeword
Return

'-------------------------------------------------------------------------------
Set_tune_bit:
Regno = &H2
Gosub Readword
Datahi = Datahi Or &B00000010
Gosub Writeword
Return

'-------------------------------------------------------------------------------
Clear_tune_bit:
Regno = &H2
Gosub Readword
Datahi = Datahi And &B11111101
Gosub Writeword
Return

'-------------------------------------------------------------------------------
Clear_seek_bit:
Regno = &H03
Gosub Readword
Datahi = Datahi And &B10111111
Gosub Writeword
Return

'-------------------------------------------------------------------------------
Setchannel:
Regno = &H02
Gosub Readword
Channel = Channel - 690
'Datahi = Channelhi
Datahi.0 = Channelhi.0
Datalo = Channello
Gosub Writeword
Return

'-------------------------------------------------------------------------------
Set_mono:
Regno = &H01
Gosub Readword
Datalo = Datalo Or &B00001000
Gosub Writeword
Return

'-------------------------------------------------------------------------------
Clear_mono:
Regno = &H01
Gosub Readword
Datalo = Datalo And &B11110111
Gosub Writeword
Return

'-------------------------------------------------------------------------------
Writeword:
I2cinit
I2cstart
I2cwbyte Arwr
I2cwbyte Regno
I2cwbyte Datahi
I2cwbyte Datalo
I2cstop
Waitms 50
Return

'-------------------------------------------------------------------------------
Readword:
I2cinit
I2cstart
I2cwbyte Arwr
I2cwbyte Regno
Waitms 50
I2cstart
I2cwbyte Arrd
I2crbyte Datahi , Ack
I2crbyte Datalo , Nack
I2cstop
Return

'****************************  registers default values ****************************************************
Regdefaults:       'start with reg01; ends with reg 00
Data &H5B05% , &HF4B9% , &H8012% , &H0400% , &H28AA% , &H4400% , &H1EE7% , &H7141% , &H007D% , &H82C6% , &H4F55%
Data &H970C% , &HB845% , &HFC2D% , &H8097% , &H04A1% , &HDF6A% , &HFFFF%

'dataset1: 5B05 for 50uS deephasis; 5B15 for 75uS deemphasis